import type { asIn, asOut } from "../../scopes/type.js";
import type { Problem, Problems } from "../../traverse/problems.js";
import type { nominal } from "../../utils/generics.js";
import type { inferDefinition, validateDefinition } from "../definition.js";
import type { PostfixParser, TupleExpression } from "./tuple.js";
export declare const parseMorphTuple: PostfixParser<"|>">;
export type Out<t = {}> = nominal<t, "out">;
export type validateMorphTuple<def extends TupleExpression, $> = readonly [
    _: validateDefinition<def[0], $>,
    _: "|>",
    _: Morph<asOut<inferDefinition<def[0], $>>, unknown>
];
export type Morph<i = any, o = unknown> = (In: i, problems: Problems) => o;
export type ParsedMorph<i = any, o = unknown> = (In: i) => inferMorphOut<o>;
export type inferMorph<inDef, morph, $> = morph extends Morph ? (In: asIn<inferDefinition<inDef, $>>) => inferMorphOut<ReturnType<morph>> : never;
type inferMorphOut<out> = unknown extends out ? Out<unknown> | undefined | null : Out<Exclude<out, Problem | undefined | null>> | Extract<out, undefined | null>;
export declare const writeMalformedMorphExpressionMessage: (value: unknown) => string;
export {};
