import type { asIn } from "../../scopes/type.js";
import type { Problems } from "../../traverse/problems.js";
import type { Domain, inferDomain } from "../../utils/domains.js";
import type { inferDefinition, validateDefinition } from "../definition.js";
import type { distributable } from "./distributableFunction.js";
import type { PostfixParser, TupleExpression } from "./tuple.js";
export declare const parseNarrowTuple: PostfixParser<"=>">;
export type Narrow<data = any> = (data: data, problems: Problems) => boolean;
export type NarrowCast<data = any, to extends data = data> = (data: data, problems: Problems) => data is to;
export type validateNarrowTuple<def extends TupleExpression, $> = readonly [
    _: validateDefinition<def[0], $>,
    _: "=>",
    _: distributable<Narrow<asIn<inferDefinition<def[0], $>>>>
];
export type inferNarrow<inDef, narrow, $> = narrow extends Narrow ? inferNarrowFunction<inferDefinition<inDef, $>, narrow> : narrow extends {
    [domain in Domain]?: Narrow;
} ? {
    [domain in keyof narrow & Domain]: inferNarrowFunction<Extract<inferDefinition<inDef, $>, inferDomain<domain>>, narrow[domain]>;
}[keyof narrow & Domain] : never;
type inferNarrowFunction<input, narrow> = narrow extends NarrowCast<input, infer to> ? to : narrow extends Narrow<input> ? input : never;
export {};
